/*
  - RUTA: /parrillaPrecios
  - PARRILLA {{channel}} - VALORIZADA
  - MUESTRA PROGRAMACION E IMPRESION, GUARDAR, COSTO TOTAL
*/
<template>
	<div class="style_Programs">
		<header style="margin: 10rem 1rem 3rem">
			<ReturnButton :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage"  :isValidate="true" style="margin-bottom:2.5rem"></ReturnButton>
		</header>
		<!-- COMPONENTE TITULO -->
		<div class="margin-title-grid">
		<app-title :Title="`PARRILLA ${chanelTransmission} - VALORIZADA`" bgColor="background-color: #4A4A4A !important"> </app-title>
		</div> 
		<el-main>
			<h1 class="title-Schedule">Programación de la {{dateString}}</h1>
			<!-- Fecha y botones -->
			<el-row class="margin-date-btn-in-grid-style" type="flex" justify="space-between">
				<div class="flex-content">
					<div style="margin-right: 50px;">
						<p style="margin-top: 0.6rem;" class="title">{{ dateString }}</p>
					</div>
					<el-date-picker
						class="date-head flex element-bloq-center"
						v-model="dateSearch"
						type="date"
						format="dd/MM/yyyy"
						value-format="timestamp"
						placeholder="Escoja una semana"
						@change="setWeek">
					</el-date-picker>
				</div>
				<div class="flex element-bloq-center">
          			<el-tooltip class="item" effect="dark" content="Guardar" placement="bottom">
						<el-button @click="saveGrid" icon="icon-save" class="btn_icons_p font-size-25" type="iconGrid"></el-button>
					</el-tooltip>

					<el-tooltip class="item" effect="dark" content="Imprimir" placement="bottom">
						<el-button @click="printPage" class="margin_l_35 btn_icons_p font-size-25" icon="icon-print" type="iconGrid" :disabled="isDisabledBtn"></el-button>
					</el-tooltip>
        			<div v-if="styleBtnAproved.isShow == false" class="text-green margin_l_35 flex element-bloq-center">
						<i class="icon-check font-size-18" style="margin-right: 8px"></i>
						<p class="font-size-17 textBold"> APROBADO </p>
					</div>
					<div v-else>
						<p class="font-size-17 margin_l_35 flex text-red-color textBold"> PENDIENTE </p>
					</div>
				</div>
			</el-row>
			<br>
			<div class="flex-content just-center">
				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_left" borderSquare="box_style_border_left"/>
				<div>
					<gridDays :haveRef="true" :days="generateDays()"/>

					<div class="grid-programs" ref="contenedor">
						<!-- class="grid-byProgram" -->
						<div v-for="(program, index) in orderByProgram" :key="index" class="grid-byProgram" :ref="`cell-${index}`" :class="[getResize(index, program)]">
							<div class="flex justify position-z-index">
								<div class="programDuration" :class="[durationProgramHeader(program.programByDay)]">
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleStartHour, program.programPrincipal.scheduleStartMin)}}</span>
									-
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleEndHour, program.programPrincipal.scheduleEndMin)}}</span>
								</div>
							</div>

							<div class="principalTitle work-break text-blue-color" :class="[durationProgramTitle(program), isAbsolute(program.programByDay, 'p-absolute')]" v-if="program.programPrincipal.typeOfContent !== 'Largometrajes' &&  program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'">{{ program.programPrincipal.programTitle }}</div>
							<!-- Titulo del programa para largometrajes -->
							<div v-else :class="[isAbsolute(program.programByDay, 'p-absolute')]">
								<p class="text-orange principalTitle work-break" :class="[durationProgramTitleLargometraje(program.programPrincipal)]">"{{ program.programPrincipal.programTitle }}"<p>
								<p class="principalTitle text-blue-color work-break" :class="[durationProgramTitle(program)]">{{ program.programPrincipal.materialTitle }}</p>
							</div>

							<div class="principalTitle principalTitle mt-2" >
								<!-- _________Nota general__________ -->
								<div style="margin-top: 1rem" v-if="program.programPrincipal.generalNoteBoss && program.programPrincipal.generalNoteBoss !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNoteBoss"> <br></div>
								<div style="margin-top: 1rem" v-if="program.programPrincipal.generalNote && program.programPrincipal.generalNote !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNote"> <br></div>
							</div>

							<!-- <div class="boxAllDaysContent" :class="[calculateTime(program.programPrincipal) > '00:15:00' ? 'mt-30 min-height-50' : 'min-height-100']"> -->
							<div class="boxAllDays" :class="[calculateTime(program.programPrincipal) > '00:15:00' ? 'mt-30 min-height-50' : 'min-height-100']">
								<!-- min-height-100 -->
								<!-- tengo mas de un dia -->
								<div class="boxByDay" v-for="(day, i) in program.programByDay" :key="i" :style="`grid-column: ${i+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" @dblclick="showEditPrice( day )">
									<div class="contentBoxByChapter" :class="[day.chapters.length >= 3 ? 'rezise-box' : '']">
										<div v-if="day.nota && day.nota !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.nota" ></div>
										<div v-if="day.noteDay && day.noteDay !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.noteDay" ></div>

										<!-- <div v-if="day.nota && day.nota !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.nota" ></div>
										<div v-if="day.noteDay && day.noteDay !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.noteDay" ></div>
										<div v-if="day.generalNoteBoss && day.generalNoteBoss !== '' " class="note work-break padding-0-10 font-size-14 text-white" v-html="day.generalNoteBoss" ></div>
										<div v-if="day.generalNote && day.generalNote !== '' " class="note work-break padding-0-10 font-size-14 text-white" v-html="day.generalNote" ></div> -->

											<div :class="[day.chapters.length >= 3 ? 'rezise-box' : '']" style="color: #4cb253 !important" >
											<div class="boxByChapter flex-content justify-content-space" v-for="(chapter, i) in day.chapters" :key="i">
												<span v-if="isShowPrice(chapter.priceByPass)" v-on:keypress.native="isNumber">
												<span> USD </span>                             
												<el-input size="small"  v-if="chapter.isEditPrice && chapter.isEditPrice == true" v-model="chapter.priceByPass" @keyup.enter.native="ocultandoInput(chapter)" v-on:keypress.native="isNumber" ></el-input>
								
												<span v-if="!chapter.isEditPrice || chapter.isEditPrice == false">
												{{ getFormat(chapter.priceByPass) }}
												</span>
													</span>
												<span v-else>
												<span v-if="chapter.isEditPrice || chapter.isEditPrice == true" > 
												<el-input size="small"  v-model="chapter.preliminaryMount" @keyup.enter.native="seteandoValor(chapter, chapter.preliminaryMount)" @change="setStyle( index, chapter.preliminaryMount, day)" v-on:keypress.native="isNumber" ></el-input>
												</span>
												</span>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<gridDays :days="generateDays()"/>
				</div>
				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_rigth" borderSquare="box_style_border_rigth"/>
			</div>
			<div class="flex-content just-center">
				<div style="display: grid; grid-template-columns: repeat(7, 170px); align-items: center; margin: 2rem 60px 2rem 60px" ref="scroll">
					<div v-for="(day, index) in priceByDay" :key="index" class="flex-content justify-content-center font-size-18"> 
						<span class="textCollapse" style="color: #00B050 !important; font-size: 18px; font-weight: 700"> 
							<span style="font-size: 18px;font-weight: 700"> USD</span> {{ getFormat(day.number) }} </span>  
				</div>
				</div>
			</div>
			<div style="font-size: 18px; font-weight: 700" class="flex-content justify_end mx-122"> 
				<span style="color: #00009 !important;">  IMPORTE SEMANAL </span> 	
				<span style="margin-left: 10px; color: #4cb253 !important">USD {{ getFormat(totalAmount) }} </span> 
			</div>
		</el-main>

    <!-- MODAL BOTON DE RETROCEDER -->
    <AppModal :show-dialog.sync="returnButtonModal"  v-if="returnButtonModal" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
      :parrafo="'Si sales de la parrilla sin GUARDAR la información se perderá.'" v-on:btnEvent="returnButtonModal = false" @btnEvent="retroceder" v-on:eventBtn="returnButtonModal = false"
      btn1="SALIR"  btn2="SEGUIR AQUÍ" classBtn1="border-red" typeBtn1="danger">
    </AppModal>
      <!-- MODAL GUARDAR -->
      <el-dialog :visible.sync="modalGuardar"
        width="33%"
        center
        :close-on-press-escape="false"
        :show-close="false"
        custom-class="dialog-orange"> 
        <el-row >
			<el-col :span="5" class="text-center"><img src="../../../assets/images/happy.svg"  alt="emoticon"></el-col>
			<el-col :span="18" :offset="1">
				<p style="margin-bottom: 0.5rem"><strong> ¡Buen trabajo! </strong></p>
				<p> La parrilla ha sido guardada. </p>        
			</el-col>
		</el-row>
      </el-dialog>

	</div>
</template>
<script>

import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'
import gridSchedule from '@/components/grid/gridSchedule'
import gridDays from '@/components/grid/gridDays'
import { modelProgramByDay } from '@/utils/util.js'
import { addingZerosToTheDay, convertFormatDayForCrusses, convertHourDate} from '@/utils/calculateTimePrograms.js'
import { convertNumberFormatUsd } from '@/utils/calculateTime.js'
import { sizeLetttersAboutProgram, calculateSchedule, sizeLetttersAboutProgramCompare } from '@/utils/calculateSizeLetters.js'
import { getFirstDay } from '@/utils/calculateTime.js'
import { months } from '@/enums.js'
import { HTTP } from '@/main.js'
import AppModal from '@/components/AppModal.vue'



export default {
	components: {
		'app-title': Title,
		ReturnButton,
		gridSchedule,
    gridDays,
    AppModal
	},
	data () {
		return {
      returnButtonModal: false,
      modalGuardar: false,
			dataTable: '',
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: '',
			secondDay: '',
			thirdDay: '',
			fourthDay: '',
			fifthDay: '',
			sixthDay: '',
			lastDay: '',
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
			endDate: '',
			orderByProgram: [],
			idOfPrograms: [],
			hour: 5,
			minute: 0,
			contentHtml: '',
			dateString: '',
			programSelected: {},
			transmission: [],
			// allDiasByProgram: [],
			timeForDay: [],
			isSelectColor: false,
			checkAllDays: [],
			changeStatus: '',
			clasificationColor: '',
			notShowSchedule: false,
			dataAllWeek: [],
			allProgramsWithGrid: [],
			chanelTransmission: this.$localStorage.get('channelTransmition'),
			priceByDay : [
				{
					name: 'Lunes',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Martes',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Miercoles',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Jueves',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Viernes',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Sábado',
					number: 0,
					currencySymbol: ''
				},
				{
					name: 'Domingo',
					number: 0,
					currencySymbol: ''
				}
			],
			dias : ['Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado', 'Domingo'],
		}
	},
	sockets:{
		updateGridPreliminary(weeks){
			if(weeks.includes(this.dateString))
				this.getWeek(this.dateString);
		},
		programarParrillaRegular(weeks){
			if(weeks.includes(this.dateString))
				this.getWeek(this.dateString);
		}
	},
	mounted(){
		let printView = false;
		let alturas = []
		let alturasImprimir=[]
		let alturasAux=[];
		for(let i=1; i<=288; i++){alturas.push['20px']};
		let templateRows = alturas.join(' ');
		const items = document.querySelectorAll('.grid-schedule');
		const boxes = document.querySelectorAll('.box_style');
		const grids = document.querySelectorAll('.grid-programs')
		boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
		grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)		

		window.addEventListener('afterprint',()=>{
			// console.log('luego de imprimir')
			printView = false;
			alturas = JSON.parse(JSON.stringify(alturasAux));
			templateRows = alturas.join(' ');
			boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
			grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
		})

		window.addEventListener('beforeprint',()=>{
			// console.log('antes de imprimir')
			printView = true;
			setTimeout(()=>{
				alturasAux = JSON.parse(JSON.stringify(alturas));
				alturas = alturas.map(altura=>Math.floor(parseInt(altura)/3)+'px')
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			},100)
			setTimeout(()=>{
				items.forEach(item=>{
					let currentStyle= item.getAttribute('style').split(';')[0];
					item.setAttribute('style',currentStyle);
				},100)
			})
			
		})

		var ro = new ResizeObserver( entries => {
			if(printView) return;
			for (let entry of entries) {
				const cr = entry.contentRect;
				const hg = parseInt(cr.height);
				let alturaUnica = parseInt(entry.target.style.gridRow);
				// console.log(alturaUnica);
				let calculateHeigth = Math.floor((Math.floor(hg)+3)/3)
				for(let j=alturaUnica -1; j<= alturaUnica+1; j++){
					alturas[j]= calculateHeigth+'px';
				}
				templateRows = alturas.join(' ');
				// console.log(templateRows);
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			}
		});

		items.forEach(item=>ro.observe(item))
	},
	methods: {
		resetPrice(data) {
			let response = data.map((e) => {
				const {number, ...rest} = e
				return {
					number: "0.00",
					...rest
				}
			})
			return response
		},
		isAbsolute(data, style) {
			let time =  this.calculateTime(data[0])
			if(data.length == 1 && time <= '00:20:00') {
				// return 'p-absolute'
				return style
			}
		},
		retroceder () {
		this.$router.push({ name: 'views'})
		},
		returnPage () {
      
      let dataModifi = JSON.stringify(this.dataAllWeek.programs) 
      let dataOriginal = this.$localStorage.get("dayToCopy")

      if (dataModifi == dataOriginal ) {
        this.$router.push({ name: 'views'})
      }
      else {
        this.returnButtonModal = true
      }

			// this.$router.push({ name: 'views'})
		},
  	saveGrid () {
			HTTP.patch('grid/update/' + this.dataAllWeek._id,
			[{	propName: "programs", value: this.dataAllWeek.programs }])
			.then(res => {
				this.modalGuardar = true
			})
			.catch(err => console.log(err));
		},
    seteandoValor (chapter, value) {
      this.$set(chapter, "priceByPass", value ) 
      this.$set(chapter, "isEditPrice", false ) 
      this.getPriceForDay(this.dataAllWeek.programs)
	},
	setStyle(index, value, program) {
		let time = this.calculateTime(program)
		let nameClass = 'resize_box'
		if(time < '00:10:00') {
			this.refResize(index, value, nameClass, 'bottom: 22px; min-height: 40px')
		} else if (time >= '00:10:00' && time <= '00:15:00') {
			this.refResize(index, value, nameClass, 'bottom: 15px; min-height: 55px')
		} else if( time > '00:15:00' && time <= '00:23:00') {
			console.log(this.$refs[`cell-${index}`], 'ppp')
			this.$refs[`cell-${index}`].forEach(item=>{
				let name ='resize'
				let data = item.getAttribute('class')
				console.log(item, 'item----')
				if(value && value !== '') {
					if(!data.includes(nameClass)) {
						item.classList.add(name)
						item.childNodes[0].childNodes[0].setAttribute('style', 'font-size: 12px; padding: 0')
						item.childNodes[1].setAttribute('style', 'top: 20px; margin: 0; padding: 0; width: 100%;')
						item.childNodes[2].setAttribute('style', 'bottom: -5px')
					}
				} else{
					item.classList.remove(name)
					item.childNodes[0].childNodes[0].setAttribute('style', '')
					item.childNodes[1].setAttribute('style', '')
					item.childNodes[2].setAttribute('style', '')
				}
			})
		}
	},
	getResize(index, program) {
		let time = this.calculateTime(program.programPrincipal)
		let chapter = program.programByDay.map((e) => {
			let counter = []
			e.chapters.forEach((e) => {
				if(e.priceByPass && e.priceByPass !== '') {
					counter.push(e.priceByPass)
				}
			})
			return counter
		})
		let chapterTransform = [].concat.apply([], chapter)
		let nameClass = 'resize_box'
		if(chapterTransform.length >= 1) {
			if(time < '00:10:00') {
				// return 'resize_box class_bottom'
				return 'resize_box class_bottom'
			} else if (time >= '00:10:00' && time <= '00:15:00') {
				return 'resize_box class_bottom_2'
			} else if( time > '00:15:00' && time <= '00:23:00') {
				return 'resize'
			}
		} else {
			return 'grid-byProgram'
		}
	},
	refResize(index, value, nameClass, style) {
		this.$refs[`cell-${index}`].forEach(item=>{
			if(value && value) {
				let value = item.getAttribute('class')
				if(!value.includes(nameClass)) {
					item.setAttribute('style', style)
					item.classList.add(nameClass)
				}
			} else {
				item.setAttribute('style', '')
				item.classList.remove(nameClass)
			}
		})
	},
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    ocultandoInput (chapter) {
		console.log(chapter, 'chapter')
		this.$set(chapter, "isEditPrice", false )
		this.getPriceForDay(this.dataAllWeek.programs)
		// chapter.isEditPrice == false
    },
    // showEditPrice (chapter) {
    //   this.$set(chapter, "isEditPrice", true )
    //   this.$set(chapter, "isEditPrice", true )
	// },
	showEditPrice (day) {
		this.$set(day.chapters[0], "isEditPrice", true )
      	this.$set(day.chapters[0], "isEditPrice", true )
		// day.chapters
	},
	getFormat (valor) {
		if ( valor && valor != 'Cortesía' ) {
			return convertNumberFormatUsd(Number(valor))
		}
		else {
			return '0.00'
		}
	},
    // getPriceForDay (allPrograms) {		
    //   this.dias.map((dia, y) => {
    //     let mount = 0
    //     let simbol = ''

    //     let filterByDay = allPrograms.filter(function(item) {
    //       return item.material && item.completeDate.includes(dia) && item.material.stringMaterialType == "Enlatado" && item.codMaterial.includes("M")
    //     })
    //     if (filterByDay.length > 0 ) {
          
    //       console.log(filterByDay, 'filterByDay')
          
    //       filterByDay.map( (el, i, arr ) => {
    //         el.chapters.map((chap) => {
    //           if (chap.numberPassOfChap) {
                
    //             if ( el.material.numChapters.length > 0 ) {
                  
    //              let capSelected = el.material.numChapters[0].arrOfChapters.filter(function(item) {
    //                 return item.id == chap.numChapter
    //               })
    //               mount += parseFloat(Number(capSelected[0].chapterPasses[chap.numberPassOfChap -1]))
    //               simbol = el.material.currencySymbol
    //             }
    //             else {
                  
    //              mount += parseFloat(el.material.broadcastPrice[chap.numberPassOfChap-1])
    //              simbol = el.material.currencySymbol
    //             }
    //           }
    //         })
    //       })
    //       let hola = this.priceByDay[y].number
    //       this.priceByDay[y].number = mount.toFixed(2)
    //       this.priceByDay[y].currencySymbol = simbol
    //     }
    //     else { 
    //       this.priceByDay[y].number = ''
    //     }
    //     console.log(filterByDay, 'filterByDay')
    //   })
    // },
     getPriceForDay (allPrograms) {		
       
      this.dias.map((dia, y) => {
        let mount = 0
        let simbol = ''

        let filterByDay = allPrograms.filter(function(item) {
          return item.completeDate.includes(dia)
        })
        
        // console.log(filterByDay, 'filterByDay')
        if (filterByDay.length > 0 ) {          
          filterByDay.map( (el, i, arr ) => {
            el.chapters.map((chap) => {
              if ( chap.priceByPass ) {
                mount += parseFloat(chap.priceByPass)
              }
            })
          })
          let hola = this.priceByDay[y].number
          this.priceByDay[y].number = mount.toFixed(2)
          this.priceByDay[y].currencySymbol = 'USD'
        }
        else { 
          this.priceByDay[y].number = '0.00'
        }
        // console.log(filterByDay, 'filterByDay')
      })
    //   console.log(this.priceByDay, 'this.priceByDay')
    },
		dowloadExcel() {
			console.log('dowloadExcel')
		},
		addClassToProgramTitle (program) {
			let hasChapters = false
			if(!(program.programByDay.length > 1)){
				if(!(program.programByDay[0].material.numChapters.length > 0)){
					hasChapters = true
				}
			}
			return hasChapters
		},
		setWeek(){
			if (this.dateSearch === '' || this.dateSearch === null) { 
				this.firstDayOfWeek = getFirstDay(new Date())
				this.startDate = getFirstDay(new Date())
				this.firstDay = this.firstDayOfWeek.getDate();
				this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
				this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
				this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
				this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
				this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
				this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
				this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))  
				this.month = months[this.firstDayOfWeek.getMonth()];
				this.month2 = months[this.endDate.getMonth()];
				this.year = this.firstDayOfWeek.getFullYear();
				this.year2 = this.endDate.getFullYear();
			} else {
				this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
				this.startDate = getFirstDay(new Date(this.dateSearch))
				this.firstDay = this.firstDayOfWeek.getDate();
				this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
				this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
				this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
				this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
				this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
				this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
				this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))
				this.month = months[this.firstDayOfWeek.getMonth()];
				this.month2 = months[this.endDate.getMonth()];
				this.year = this.firstDayOfWeek.getFullYear();
				this.year2 = this.endDate.getFullYear();
			}

			if (this.month == this.month2 && this.year == this.year2  ) {
				this.dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
			} else if (this.month !== this.month2 && this.year == this.year2 ) {
				this.dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
			} else if (this.month !== this.month2 && this.year !== this.year2) {
				this.dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
			}
		},
		async getWeek (weekSelect) {
			this.priceByDay = this.resetPrice(this.priceByDay)
			this.orderByProgram = []
			this.idOfPrograms = []
			const responseText = "Week not found weekDate"
			const responseHTTP = await HTTP.post('grid/filterWeek',{week:weekSelect});
			const coincidence = responseHTTP.data.ok? responseHTTP.data.grid : responseText;

			if(coincidence && coincidence !== responseText) {      
				this.orderByProgram = []
        		this.dataAllWeek = coincidence
				const { programs, approvedWeek } = coincidence
        		this.allProgramsWithGrid = coincidence
        
       			this.$localStorage.set('dayToCopy', JSON.stringify(programs))
				
		// if(approvedWeek) {
      	this.getPriceForDay(coincidence.programs)
					// FILTRO POR CANAL DE TRANSMISION
					let isTrue = false
					let programsByChannel = []
					programs.map((program) => {
						if(program.refProgram.checkedChanels.length > 0){
							program.refProgram.checkedChanels.map((channel)=> {
								if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
									programsByChannel.push(program)
								}
							})
						} else {
							programsByChannel.push(program)
						}
					})
					// FILTRO PARA MOSTRAR SOLO PROGRAMAS CON MATERIALES QUE EXISTEN
					// let programsWithMatExist = []
					// programsByChannel.map((el) => {
					// 	if(el.codMaterial !== '') {
					// 		programsWithMatExist.push(el)
					// 	}
					// })
          // this.getPriceForDay(programsWithMatExist)
          
          // console.log(programsWithMatExist, 'programsWithMatExist')
          
					// RECORRE LA DATA QUE TRAE LA RESPUESTA
					programsByChannel.map((program)=>{
						const {refProgram: {_id}} = program

						const object = {
							programPrincipal: this.modelPrincipalProgram(program),
							programByDay: [modelProgramByDay(program)]
						}

						if(this.idOfPrograms.includes(_id) == false){
							// INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
							this.idOfPrograms.push(_id)
							this.orderByProgram.push(object)
						} else {
							const {refProgram: {codeDays}} = program

							let arrSamePrograms = []
							this.orderByProgram.map((program, index)=>{
								if(program.programPrincipal._id == _id){
									arrSamePrograms.push(index)
								}
							})
							
							let daySelected = this.getDayCode(program.completeDate)
							
							let addToProgram = false
							//RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
							for(let i=0; i<arrSamePrograms.length; i++){
								let programSelected = this.orderByProgram[arrSamePrograms[i]]
								let daysSaved = []
								//GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
								programSelected.programByDay.map((programDay)=>{
									const day = programDay.completeDate
									const daySaved = this.getDayCode(day)
									daysSaved.push(daySaved)
								})
								
								//RECORRE LOS DIAS DEL PROGRAMA 
								codeDays.map((day, index)=>{
									//VERIFICA EL DIA SELECCIONADO
									if(day == daySelected){
										//SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
										daySelected = (daySelected == 1)? 8: daySelected
										//VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
										if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
											//RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
											daysSaved.map((savedDay)=>{
												//VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
												if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
													// VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
													const indexArrProgram = programSelected.programByDay.length -1
													const lastProgram = programSelected.programByDay[indexArrProgram]
													const programByDay = modelProgramByDay(program)
													
													let lastProgramTimeStart = this.convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
													let lastProgramTimeEnd = this.convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

													let programSelectedTimeStart = this.convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
													let programSelectedTimeEnd = this.convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)

													if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
														addToProgram = true
														programSelected.programByDay.push(modelProgramByDay(program))
													} else {
														addToProgram = false
													}
													
												}
											})
										}
									}
								})
							}

							//AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
							if(addToProgram == false){
								this.orderByProgram.push(object)
							}

						}
					})
				// }
    	}
  			
			this.orderByProgram = this.sortByHour(this.orderByProgram)
			// console.log(this.orderByProgram, 'this.orderByProgram')
			this.fillingGrid(this.orderByProgram)
			// })
			// .catch(err => console.log(err))
		},
		// modelProgramByDay(program) {
		// 	const programByDay = {
		// 		chapters: program.chapters,
		// 		dailyCuttingProgram: program.dailyCuttingProgram,
		// 		crushedPrograms: program.crushedPrograms,
		// 		replacementPrograms: program.replacementPrograms,
		// 		isShowTemporadas: program.isShowTemporadas,
		// 		programGridTitle: program.programGridTitle,
		// 		dailyProgramDate: program.dailyProgramDate,
		// 		completeDate: program.completeDate,
		// 		scheduleStartHour: program.scheduleStartHour,
		// 		scheduleStartMin: program.scheduleStartMin,
		// 		scheduleEndHour: program.scheduleEndHour,
		// 		scheduleEndMin: program.scheduleEndMin,
		// 		materialTitle: program.materialTitle,
		// 		codMaterial: program.codMaterial,
		// 		material: program.material,
		// 		refProgram: program.refProgram,
		// 		materialReferencia: program.materialReferencia,        
		// 		programDate: program.programDate,
		// 		geminisCodeProgram: program.geminisCodeProgram,
		// 		IsCap: program.IsCap,
		// 		EstTemp: program.EstTemp,
		// 		Estado: program.Estado,
		// 		bgColorByProgram: program.bgColorByProgram,
		// 		chapterColor: program.chapterColor,
		// 		seasonStateColor: program.seasonStateColor,
		// 		stateChapterColor: program.stateChapterColor,
		// 		rerunChapterColor: program.rerunChapterColor,
		// 		nota: program.nota,
		// 		isUnitPrice: program.isUnitPrice,
		// 		unitPriceColor: program.unitPriceColor,
		// 		IsCodProvider: program.IsCodProvider,
		// 		codProviderColor: program.codProviderColor,
		// 		IsPricePass: program.IsPricePass,
		// 		pricePassColor: program.pricePassColor,
		// 		generalNote: program.generalNote
      	// 	}
		// 	return programByDay
		// },
		modelPrincipalProgram(program){
			let exitMaterialReferencia = program.materialReferencia ? program.materialReferencia.typeOfContent : ''
			let conditionalTypeOfContent = program.typeOfContent ? program.typeOfContent : exitMaterialReferencia
			const programPrincipal = {
				_id: program.refProgram._id,
				arrCheckCrosses: program.refProgram.arrCheckCrosses,
				checkedChanels: program.refProgram.checkedChanels,
				checkedSignals:program.refProgram.checkedSignals ,
				codProgram: program.refProgram.codProgram,
				codeDays: program.refProgram.codeDays,
				geminisCode: program.refProgram.geminisCode,
				programTitle: program.refProgram.programTitle,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				transmissionDays: program.refProgram.transmissionDays,
				classification: program.classification,
				isTemporada: program.isTemporada,
				isClasification: program.isClasification,
				clasificationColor: program.clasificationColor,
				seasonColor: program.seasonColor,
				isUnitPrice: program.isUnitPrice,
				unitPriceColor: program.unitPriceColor,
				generalNote: program.generalNote,
				IsCodProvider: program.IsCodProvider,
				providerCode: program.providerCode,
				transmissionDaysDescription: this.dayStartAndDayEnd(program.refProgram.transmissionDays),
				typeOfContent: conditionalTypeOfContent,
				materialTitle: program.materialTitle,
				materialHasChapter: program.materialHasChapter,
				materialType: program.materialType,
				firstActor: program.firstActor,
				secondActor: program.secondActor,
				unitPrice: program.unitPrice,
				season: program.season,
				stringMaterialType: program.stringMaterialType,
				codeFeatureFilm: program.codeFeatureFilm,
				materialReferencia: program.materialReferencia,
				material: program.material,
				programDate: program.programDate,
				chapters: program.chapters
			}
			return programPrincipal
		},
		convertToMinutes(hours, minutes){
			const result = (hours * 60) + minutes
			return result
		},
		sortByHour(programs) {
			return programs.slice().sort(function(a, b) {
				//SE ORDENA POR TOTAL DE MINUTOS
				const firstProgramMinutesTotal = (a.programPrincipal.scheduleStartHour * 60) + a.programPrincipal.scheduleStartMin
				const secondProgramMinutesTotal = (b.programPrincipal.scheduleStartHour * 60) + b.programPrincipal.scheduleStartMin
				
				return firstProgramMinutesTotal - secondProgramMinutesTotal;
			});
		},
		getDayCode (day){
			let daySelected = day.split(' ')[0]
			let dayCode = ''
			switch(daySelected){
				case 'Lunes':
					dayCode = 2
				break;
				case 'Martes':
					dayCode = 3
				break;
				case 'Miércoles':
					dayCode = 4
				break;
				case 'Jueves':
					dayCode = 5
				break;
				case 'Viernes':
					dayCode = 6
				break;
				case 'Sábado':
					dayCode = 7
				break;
				case 'Domingo':
					dayCode = 1
				break;
			}

			return dayCode
		},
		fillingGrid (data) {
			let programs = data
			this.contentHtml = ''
			programs.map((program, index) => {
				let template = ''
				const nameProgram = program.programPrincipal.programTitle	
				const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))

        		const daysInOrder = arrDays.sort()

				let hourStart = program.programPrincipal.scheduleStartHour
				let hourEnd = program.programPrincipal.scheduleEndHour
				let minEnd = program.programPrincipal.scheduleEndMin
				let minStart = program.programPrincipal.scheduleStartMin

				if (hourStart <5 ) {
				hourStart = Number(hourStart) + 24
				}
				else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
				hourStart = Number(hourEnd) + 24
				}
				
				if (hourEnd <5) {
				hourEnd = Number(hourEnd) + 24
				} 
				else if (hourEnd == 5 && minEnd<=16) {
				hourEnd = Number(hourEnd) + 24
				}
			
				const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
				const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)

				let initGrid = Math.round(totalMinutesStart/5 - 63.2)
				let finalGrid = Math.round(totalMinutesEnd/5 - 63.2)

				let concatGrid
				
				if(program.programPrincipal.chapters.priceByPass) {
					console.log((finalGrid - initGrid) +2, 'aqqqq')
					concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ ((finalGrid - initGrid) +2) + ' / ' + (daysInOrder[(daysInOrder.length)-1])
				} else {
					concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])
				}
				

				template = `<div class="grid-programsByDay" :class="[${finalGrid - initGrid}]" style="grid-area: ${concatGrid};">
								${nameProgram}
							</div>`
				this.contentHtml += template

				let divObj = 'cell-'+index
				this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
			})
		},
		dayStartAndDayEnd(val) {
			if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				const text = `${val[0]} ${connect} ${val[counter-1]}`
				return {
					text,
					value: counterCondicional
				}
			} else if(val && val.length == 1) {
				return {
					text: val[0],
					value: 1
				}
			}
		},
		/*___________________Métodos para crear el array de las horas ____________________*/
		getTime(firstTime, secondTime, operator) {
			const secs1 = this.stringToSeconds(firstTime)
			const secs2 = this.stringToSeconds(secondTime)
			let secsDif
			if(operator == 'sum') {
				secsDif = secs1 + secs2
			} else {
				if(secs1 > secs2) {
					secsDif = secs1 - secs2
				} else {
					secsDif = secs2 - secs1
				}
			}
			// const secsDif = operator == 'sum' ? (secs1 + secs2) : (secs1 - secs2)
			return this.secondsToTime(secsDif)
		},
		stringToSeconds(tiempo) {
			let sep1 = tiempo.indexOf(":")
			let sep2 = tiempo.lastIndexOf(":")
			let hor = tiempo.substr(0, sep1)
			let min = tiempo.substr(sep1 + 1, sep2 - sep1 - 1)
			return Number(min) * 60 + Number(hor) * 3600
		},
		secondsToTime(secs) {
			let hor = Math.floor(secs / 3600)
			let min = Math.floor((secs - hor * 3600) / 60)
			let sec = secs - hor * 3600 - min * 60
			// return this.padNmb(hor, 2) + ":" + this.padNmb(min, 2)
			return (
				this.padNmb(hor, 2) +
				":" +
				this.padNmb(min, 2) +
				":" +
				this.padNmb(sec, 2)
			)
		},
		padNmb(nStr, nLen) {
			const sRes = String(nStr)
			const sCeros = "0000000000"
			return sCeros.substr(0, nLen - sRes.length) + sRes
		},		
		recordArray(firstTime, secondTime, operator, record) {
			const arr = [firstTime]
			for (let i = 0; i < record; i++) {
				arr.push(this.getTime(arr[i], secondTime, operator));
			}
			return arr
		},
		formatedArray() {
			const b = this.recordArray("05:30:00", "00:15:00", 'sum', 74).concat(this.recordArray("00:15:00", "00:15:00", 'sum', 19))
			const c = b.unshift("05:16:00")
			const d = b.map((e) => e.slice(0, 5))
			return d
		},
		isHaveActors(val) {
			let value, arr
			if(val && val.artisticInfo) {
				let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
				let counterActors = exitsActors.length
				if(counterActors > 2) {
					arr = [exitsActors[0], exitsActors[1]]
				} else {
					arr = exitsActors
				}
				value = arr
			}
			return value
		},
		printPage() {
			sessionStorage.setItem('orderByProgram', JSON.stringify(this.orderByProgram))
			sessionStorage.setItem('allProgramsWithGrid', JSON.stringify(this.allProgramsWithGrid))
			sessionStorage.setItem('dateString', JSON.stringify(this.dateString))
			sessionStorage.setItem('firstDay', JSON.stringify(this.firstDay))
			sessionStorage.setItem('secondDay', JSON.stringify(this.secondDay))
			sessionStorage.setItem('thirdDay', JSON.stringify(this.thirdDay))
			sessionStorage.setItem('fourthDay', JSON.stringify(this.fourthDay))
			sessionStorage.setItem('fifthDay', JSON.stringify(this.fifthDay))
			sessionStorage.setItem('sixthDay', JSON.stringify(this.sixthDay))
			sessionStorage.setItem('lastDay', JSON.stringify(this.lastDay))
			this.$router.push({ name: 'viewPrintPrice', params: {grid: 'precios'}})
		},
		calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
			return calculateSchedule(scheduleStartHour, scheduleStartMin)
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
			
			let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
			let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )
			
			let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
			let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
			let hourDiff = timeEnd - timeStart
			let secDiff = hourDiff / 1000
			let minDiff = hourDiff / 60 / 1000
			let hDiff = hourDiff / 3600 / 1000
			let result = {}
			result.hours = Math.floor(hDiff)
			result.minutes = minDiff - 60 * result.hours
			
			let response =  `${this.calculateHour(String(result.hours))}:${this.calculateHour(String(result.minutes))}:00`
			return response
		},
		conditionalDate(val) {
			let getTime = val.split(":")
			let getHour = String(getTime[0])
			let hour = this.calculateHour(getHour)
			let getMin = String(getTime[1])
			let min = this.calculateHour(getMin)
			let conditionalHour = hour === '00' ? '24' : hour
			// let time = val == '00:00' ? '24:00:00' : `${hour}:${min}:00`
			let time = `${conditionalHour}:${min}:00`
			return time
		},
		calculateHour(hour) {
			return hour.length >= 2 ? hour : `0${hour}`
		},
		durationProgramTitle(program) {
			const data = this.calculateTime(program.programPrincipal)
			let conditional = program.programByDay.length == 1 ? true : false
			const {programTitle, materialTitle, typeOfContent} = program.programPrincipal
			let time
			if(conditional) {
				let oneWord = materialTitle.split(' ')
				if(oneWord.length == 1) {
					if(typeOfContent == 'Largometrajes' || typeOfContent == 'LARGOMETRAJES') {
						time = materialTitle.length >= 10 ? 'font-size-18' : 'font-size-22'
					} else {
						time = this.stylesForProgramTitle(data, conditional, programTitle)
					}
				} else {
					// console.log(programTitle, 'one word material 11')
					time = this.stylesForProgramTitle(data, conditional, programTitle)
				}
			} else {
				// console.log(programTitle, '22 a mas')
				time = this.stylesForProgramTitle(data, conditional, programTitle)
			}
			return time
		},
		stylesForProgramTitle(data, conditional, programTitle) {
			let time
			if(data <= '00:00:00' ) {
				time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18' ,14)
			} else if(data <= '00:05:00') {
				time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15' ,14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = 'font-size-14 t-5 font-weight-0'
			} else if(data > '00:15:00' && data <= '00:30:00') {
				// time = 'font-size-14 font-weight-0'
				time = programTitle.length <= 14 ? 'font-size-14 font-weight-0' : 'font-size-14 font-weight-0 m-i-0'
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = 'font-size-18'
			} else {
				time = 'font-size-24'
			}
			return time
		},
		durationProgramTitleLargometraje(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-8', 'size-10')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'size-10', 'font-size-11')
			} else {
				time = 'letters-middle'
			}
			return time
		},
		durationProgramHeader(program) {
			const {programTitle} = program[0]
			const data = this.calculateTime(program[0])
			let conditional = program.length == 1 ? true : false
			let time
			if(conditional && (data <= '00:10:00'|| data == '00:00:00' )) {
				return programTitle && programTitle.length <= 14 ? 'font-size-10 p-0' : 'hidden'
			} else {
				if(data < '00:10:00') {
					time = programTitle && programTitle.length >= 14 ? 'hidden' : 'font-size-12 p-0'
				} else if(data >= '00:10:00' && data <= '00:15:00') {
					time = 'font-size-14 p-0'
				} else if (data > '00:15:00' && data <= '00:45:00') {
					time = data < '00:25:00' ? 'font-size-16 p-0' : 'font-size-16'
				} else {
					time = 'font-size-17'
				}
				return time
			}
		},
		generateDays() {
			const days = [
				{
					name: 'Lunes',
					number: addingZerosToTheDay(this.firstDay),
				},
				{
					name: 'Martes',
					number: addingZerosToTheDay(this.secondDay),
				},
				{
					name: 'Miercoles',
					number: addingZerosToTheDay(this.thirdDay),
				},
				{
					name: 'Jueves',
					number: addingZerosToTheDay(this.fourthDay),
				},
				{
					name: 'Viernes',
					number: addingZerosToTheDay(this.fifthDay),
				},
				{
					name: 'Sábado',
					number: addingZerosToTheDay(this.sixthDay),
				},
				{
					name: 'Domingo',
					number: addingZerosToTheDay(this.lastDay),
				}
			]
			return days
		},
		isShowPrice(val) {
			let type = typeof(val) == "number" ? String(val) : val
			return type
		}
  },
  computed: {
	returnOrderByProgram() {
		return this.orderByProgram
	},
    totalAmount () {
	  let total = 0
	//   console.log(this.priceByDay, 'this.priceByDay')
      this.priceByDay.map((el, i, arr) => {
        total += parseFloat(Number(el.number))
	  })
	//   console.log(total, 'total')
      return total
    },
    isDisabledBtn() {
      return this.orderByProgram.length > 0 ? false : true
    },
  	styleBtnAproved () {
    	let obj = {}
			if(this.orderByProgram.length > 0 && this.dataAllWeek.approvedWeek) {
				obj.name ='APROBADO'
				obj.status = true
				obj.isShow = false
			} else {
				obj.name ='APROBAR'
				obj.status = this.isDisabledBtn
				obj.isShow = true
			}
			return obj
		},
  },
	created () {
		this.setWeek()
		this.timeForDay = this.formatedArray()	
	},
	watch: {
		dateString:{
			handler(newVal, oldVal){
				if(newVal !== ''){
					this.getWeek(newVal)
				}
			},
		}
	},
	updated(){
		if(this.orderByProgram.length > 0){
			this.fillingGrid(this.orderByProgram)
		}
	}
}
</script>

<style >
  .grid-format {
    display: grid;
    grid-template-columns: repeat(7, 170px);
    align-items: center;
  }
  .principalTitle_2 {
		font-weight: 700;
		text-transform: uppercase;
		text-align: center;
		top: 25px;
		margin-top: 10px;
		padding: 0 10px;
		margin-bottom: 5px;
		color: black;
		z-index: 10;
		/* position: relative; */
		width: calc(100% - 21px);
	}
</style>